import java.io.*;

public class File {
	protected InputStream in;

	public File(String name) throws IOException {
		in = getClass().getResourceAsStream(name);
	}

	public int read() throws IOException {
		return in.read();
	}

	public int read(byte[] b) throws IOException {
		return in.read(b);
	}

	public int read(byte[] b, int off, int len) throws IOException {
		return in.read(b, off, len);
	}

	public byte readByte() throws IOException {
		return (byte) read();
	}

	public int readInt() throws IOException {
		return (int) (read() | read() << 8 | read() << 16 | read() << 24);
	}

	public short readShort() throws IOException {
		return (short) (read() | read() << 8);
	}
	
	public String readFixedString(int len) throws IOException {
		byte[] b = new byte[len];
		read(b);
		return Cp866.toString(b);
	}

	public void skip(long offset) throws IOException {
		in.skip(offset);
	}

	public void close() throws IOException {
		in.close();
	}
}
