public class Input {
	private static final int off = 64;  // Кол-во кодов со знаком минус
	private static final int max = 256; // Максимальное кол-во кодов
	private static final int size = 8;  // Размер очереди

	// Кольцевой буфер для очереди
	private static int[] code = new int[size];
	private static int[] stat = new int[size];
	private static int beg, end;
	
	private static boolean[] keys = new boolean[max];

	public static boolean getKeyPressed(int i) {
		return keys[i + off];
	}

	public static void pushKey(int keyCode, int keyStatus) {
		code[end] = keyCode;
		stat[end] = keyStatus;
		end = (end + 1) % size;
		
		keys[keyCode + off] = (keyStatus != 0);
	}

	public static boolean hasKeyEvent() {
		return (beg != end);
	}
	
	// [0] - код; [1] - нажатие
	public static void getKeyEvent(int k[]) {
		if(beg == end) {
			k[0] = 0;
			k[1] = 0;
		} else {
			k[0] = code[beg];
			k[1] = stat[beg];
			beg = (beg + 1) % size;
		}
	}
}