import java.lang.*;

public class Main implements Runnable {
	static int ts = 8; // Размер тайла
	
	static int lvl = 1;
	//static int camx = 400, camy = 400;
	static int camx = 0, camy = 0;
	static Texture gui1, gui2;
	static Player pl[] = new Player[1];
	
	static Texture stepTile = Texman.makePseudoTexuture(0x7FFFFF00, true);
	
	private static int middle(int i, int min, int max) {
		return (i < min) ? (min) : ((i > max) ? max : i);
	}
	
	private static void drawWalls(int z, int minx, int miny, int maxx, int maxy) {
		for(int y = miny; y < maxy; y++)
			for(int x = minx; x < maxx; x++)
				if(Map.tile[z][x][y] != 0)
					Video.draw(Texman.tex[Map.tile[z][x][y] - 1], x * ts - camx, y * ts - camy);
	}
	
	private static void draw() {
		int w = Video.width() - gui1.getWidth();
		int h = Video.height();
		
		Video.setColor(0, 0, 0);
		Video.fillRect(0, 0, w, h);
		
		if(pl != null && pl[0] != null) {
			camx = pl[0].x - w / 2 + pl[0].w / 2;
			camy = pl[0].y - h / 2 + pl[0].h / 2;
		}
		
		// Ограничение камеры на границе карты
		camx = middle(camx, 0, Map.width * ts - w);
		camy = middle(camy, 0, Map.height * ts - h);
		
		// Ограничение отрисовки тайлов в области видимости
		// Texman.maxt* - для корректной отрисовки тайлов при размерах больше ts
		int minx = middle((camx - Texman.maxtw) / ts, 0, Map.width);
		int miny = middle((camy - Texman.maxth) / ts, 0, Map.height);
		int maxx = middle((camx + w) / ts + 1, 0, Map.width);
		int maxy = middle((camy + h) / ts + 1, 0, Map.height);
		
		// Отрисовка неба
		int sx = -(camx * (Map.sky.getWidth() - w) / (Map.width * ts - w));
		int sy = -(camy * (Map.sky.getHeight() - h) / (Map.height * ts - h));
		Video.draw(Map.sky, sx, sy);
		
		// Отсовка заднего плана
		drawWalls(0, minx, miny, maxx, maxy);
		
		for(int i = 0; i < pl.length; i++) {
			Player p = pl[i];
			Video.setColor(63, 0, 0);
			Video.drawRect(p.x - camx, p.y - camy, p.w, p.h);
		}
		
		// Отсовка переднего плана
		drawWalls(1, minx, miny, maxx, maxy);
		
		for(int y = miny; y < maxy; y++)
			for(int x = minx; x < maxx; x++)
				if(Map.tile[2][x][y] == 4) // Ступенька
					Video.draw(stepTile, x * ts - camx, y * ts - camy);
		
		
		Video.draw(gui1, w, 0);
		Video.draw(gui2, w, gui1.getHeight());
		
		Video.setColor(0, 0, 0);
		Video.drawText("vx = " + pl[0].vx + " vy = " + pl[0].vy + " j = " + pl[0].canjmp, w + 2, 2);
		
		Video.update();
		try { Thread.sleep(50); } catch(Exception e) {}
	}
	
	private void kbd() throws Exception {
		if(Input.getKeyPressed(-1))
			pl[0].goUp();
		if(Input.getKeyPressed(-2))
			pl[0].goDown();
		if(Input.getKeyPressed(-3))
			pl[0].goLeft();
		if(Input.getKeyPressed(-4))
			pl[0].goRight();
		
		int[] k = new int[2];
		while(Input.hasKeyEvent()) {
			Input.getKeyEvent(k);
			if(k[1] != 0 && k[0] == 42) {
				++lvl;
				if(lvl > 19)
					lvl = 1;
				Map.loadMap(lvl);
			}
				
		}
	}
	
	private static void phy() {
		for(int i = 0; i < pl.length; i++) {
			Player p = pl[i];
			
			p.action();
		}
	}
	
	public void run() {
		try {
			Resource.loadWad("/D2Dv140/DOOM2D.WAD");
			Palette.loadDefault("PLAYPAL");
			gui1 = Texman.loadTexture("STONE", false);
			gui2 = Texman.loadTexture("STONE2", false);
			Map.loadMap(lvl);
			
			pl[0] = new Player(Map.spawnx, Map.spawny - 24, 8 * 2, 24);
			System.out.println("Max wall size w = " + Texman.maxtw + " h = " + Texman.maxth);
			
			while(true) {
				kbd();
				phy();
				draw();
			}
		} catch(Exception e) {
			e.printStackTrace();
		}

//		Midlet.self.notifyDestroyed();
	}
}
