import java.io.*;

public class Palette {
	public static int[] def;

	/* Каждый компонент цвета в диапазоне 0..63 */
	public static int[] loadPalette(File fp) throws Exception {
		int[] pal = new int[256];	
		for(int i = 0; i < 256; i++)
			pal[i] = (0xff << 24) | ((fp.read() << 2) << 16) | ((fp.read() << 2) << 8) | (fp.read() << 2);
		return pal;
	}

	public static int[] loadPalette(String name) throws Exception {
		File fp = Resource.openLump(name);
		int[] pal = loadPalette(fp);
		fp.close();
		return pal;
	}
	
	public static void loadDefault(String name) throws Exception {
		def = loadPalette(name);
	}
}
