public class Physics {
	static final int ts = 8;

	static final double[] viscosity = {
		// Вязкость(или твёрдость) тайла.
		// Значение 0..1
		// Чем больше, тем труднее проходить
		0.0, // 0: Пустота
		1.0, // 1: Стена
		1.0, // 2: Закрытая дверь
		0.0, // 3: Открытая дверь
		1.0, // 4: Ступенька
		0.5, // 5: Вода
		0.5, // 6: Кислота 1
		0.5  // 7: Кислота 2
	};

	public static class Object2D {
		public int x, y;
		public int w, h;
		public double vx, vy;
		public boolean canjmp;
	}
	
	// Копипаста, ликвидировать
	private static int middle(int i, int min, int max) {
		return (i < min) ? (min) : ((i > max) ? max : i);
	}
	
	private static int normalize(int i) {
		return (i < 0) ? (-1) : ((i > 0) ? 1 : 0);
	}
	
	private static int negate(int i) {
		return (i > 0) ? (-i) : (Math.abs(i));
	}
	
	private static boolean solid(int x, int y) {
		switch(Map.tile[2][x][y]) {
		case 1: // Стена
		case 2: // Дверь
			return true;
		}
		return false;
	}
	
	private static boolean water(int x, int y) {
		switch(Map.tile[2][x][y]) {
		case 5: // Вода
		case 6: // Кислота 1
		case 7: // Кислота 2
			return true;
		}
		return false;
	}
	
	/* Столкновение со ступенькой */
	private static boolean solidStep(Object2D obj, int x, int y) {
		return (Map.tile[2][x][y] == 4 && obj.vy >= 0 && obj.y + obj.h == y * ts /*&& Map.tile[2][x][y - 1] != 4*/);
	}
	
	public static boolean solidCollision(Object2D obj) {
		int minx = middle(obj.x / ts, 0, Map.width);
		int miny = middle(obj.y / ts, 0, Map.height);
		int maxx = middle((obj.x + obj.w) / ts + 1, 0, Map.width);
		int maxy = middle((obj.y + obj.h) / ts + 1, 0, Map.height);
		
		for(int x = minx; x < maxx; x++)
			for(int y = miny; y < maxy; y++)
				if(solid(x, y) || solidStep(obj, x, y))
					return true;
		
		return false;
	}
	
	public static boolean checkCollision(Object2D obj, int type) {
		int minx = middle(obj.x / ts, 0, Map.width);
		int miny = middle(obj.y / ts, 0, Map.height);
		int maxx = middle((obj.x + obj.w) / ts + 1, 0, Map.width);
		int maxy = middle((obj.y + obj.h) / ts + 1, 0, Map.height);
		
		for(int x = minx; x < maxx; x++)
			for(int y = miny; y < maxy; y++)
				if(Map.tile[2][x][y] == type)
					return true;
		
		return false;
	}
	
	public static boolean pointCollision(int x, int y, int type) {
		x = x / ts;
		y = y / ts;
		return x >= 0 && x < Map.width && y >= 0 && y < Map.height && Map.tile[2][x][y] == type;
	}
	
	public static boolean waterPointCollision(int x, int y) {
		x = x / ts;
		y = y / ts;
		return x >= 0 && x < Map.width && y >= 0 && y < Map.height && water(x, y);
	}

	public static void jump(Object2D obj, int vel) {
		if(obj.canjmp)
			obj.vy = -vel;
		obj.canjmp = false;
	}
	
	public static void calc(Object2D obj) {
		double p = 0.01; // Точность

		for(double i = 0; i < Math.abs(obj.vx); i += p) {
			obj.x += ts * p;
			if(solidCollision(obj)) {
				obj.x += negate(vecx);
				obj.vx = 0;
				break;
			}
		}

		/*
		for(int i = 0; i < Math.abs(obj.vy); i++) {
			obj.y += vecy;
			if(solidCollision(obj)) {
				obj.canjmp = (vecy >= 0);
				obj.y += negate(vecy);
				obj.vy = 0;
				break;
			}
		}
		*/
	}
}
