/* Менеджер текстур */

public class Texman {
	public static Texture[] tex;
	public static int maxtw, maxth;
	
	public static void resetWalls(int max) {
		maxtw = maxtw = 0;
		tex = new Texture[max];
	}
	
	public static Texture loadTexture(String name, boolean alpha) throws Exception {
		File fp = Resource.openLump(name);
		int w = fp.readShort();
		int h = fp.readShort();
		int x = fp.readShort();
		int y = fp.readShort();
		
		int len = w * h;
		int[] rgb = new int[len];
		for(int i = 0; i < len; i++) {
			int id = fp.read();
			rgb[i] = (alpha && id == 0x00) ? 0x00 : Palette.def[id];
		}

		fp.close();
		// Инвертируем знак. Хз почему так, но это работает.
		x = (x > 0) ? -x : Math.abs(x);
		y = (y > 0) ? -y : Math.abs(y);
		return new Texture(rgb, x, y, w, h, alpha);
	}
	
	public static Texture makePseudoTexuture(int color, boolean alpha) {
		final int ts = 8;
		int[] rgb = new int[ts * ts];
		for(int i = 0; i < ts * ts; i++)
			rgb[i] = color;
		return new Texture(rgb, 0, 0, ts, ts, alpha);
	}
	
	public static void loadWall(String name, int type, int id) throws Exception {
		System.out.println("Load wall '" + name + "' ["+ type + "] as " + id);
		name = name.toUpperCase();
		
		Texture img;
		if(name.equals("_WATER_0"))
			img = makePseudoTexuture(0x7F0000FF, true); // Вода
		else if(name.equals("_WATER_1"))
			img = makePseudoTexuture(0x7F00FF00, true); // Кислота
		else if(name.equals("_WATER_2"))
			img = makePseudoTexuture(0xBFBF0000, true); // Кровь
		else
			img = loadTexture(name, (type == 1));
		
		// Проверка максимального размера текстуры
		// Нужно для правильной отрисовки текстур с не стандартными размерами
		int tw = img.getWidth();
		int th = img.getHeight();
		maxtw = (maxtw < tw) ? tw : maxtw;
		maxth = (maxth < th) ? th : maxth;		
		tex[id] = img;
	}
}