import javax.microedition.lcdui.*;

public class Video extends Canvas {
	private static Image buf;
	private static Graphics g;
	
	public Video() {
		buf = Image.createImage(this.getWidth(), this.getHeight());
		g = buf.getGraphics();
	}

	protected void paint(Graphics g) {
		g.drawImage(buf, 0, 0, 0);
	}
	
	protected void keyPressed(int keyCode) {
		Input.pushKey(keyCode, 1);
	}
	
	protected void keyReleased(int keyCode) {
		Input.pushKey(keyCode, 0);
	}
	
	public static void draw(Texture img, int x, int y) {
		g.drawImage(img.img, x + img.x, y + img.y, 0);
	}
	
	public static void setColor(int rr, int gg, int bb) {
		g.setColor(rr, gg, bb);
	}
	
	public static void drawRect(int x, int y, int w, int h) {
		g.drawRect(x, y, w, h);
	}
	
	public static void fillRect(int x, int y, int w, int h) {
		g.fillRect(x, y, w, h);
	}
	
	public static void drawText(String s, int x, int y) {
		g.drawString(s, x, y, 0);
	}
	
	public static int width() {
		return buf.getWidth();
	}
	
	public static int height() {
		return buf.getHeight();
	}
	
	public static void update() {
		Midlet.video.repaint();
		Midlet.video.serviceRepaints();
	}
}
