import java.io.*;
import java.lang.*;

public class Wad {
	public class Lump {
		public String name;
		public int offset;
		public int length;
	}

	public String name;
	public boolean patch;
	public Lump[] lumps;

	public Wad(String name) throws Exception {
		this.name = name;
		File fp = new File(name);
		
		/* Проверяем тип ВАДа */
		String head = fp.readFixedString(4);
		if(head.equals("PWAD"))
			patch = true;
		else if(!head.equals("IWAD"))
			throw new Exception(name + ": Invalid WAD");

		int maxLumps = fp.readInt();
		lumps = new Lump[maxLumps];
		
		/* 12 = размер прочитанного заголовка */
		int dirOffset = fp.readInt() - 12;
		fp.skip(dirOffset);
		
		/* Читаем список лампов */
		byte[] s = new byte[8];
		for(int i = 0; i < maxLumps; i++) {
			lumps[i] = new Lump();
			lumps[i].offset = fp.readInt();
			lumps[i].length = fp.readInt();
			
			fp.read(s);
			lumps[i].name = Cp866.toString(s);
			System.out.println(lumps[i].name + '\t' +
				Integer.toHexString(lumps[i].offset) + '\t' +
				lumps[i].length);
		}

		fp.close();
	}

	public Lump findLump(String name) throws Exception {
		int len = lumps.length;
		for(int i = 0; i < len; i++)
			if(lumps[i].name.equals(name))
				return lumps[i];
		throw new Exception(name + ": No such lump");
	}

	public File openLump(String name) throws Exception {
		Lump lump = findLump(name);
		File fp = new File(this.name);
		fp.skip(lump.offset);
		return fp;
	}
}
